error_log  /var/log/nginx/nginx.error.log warn;

server {
    listen 80;
    listen [::]:80;
    server_name localhost;

    access_log /var/log/nginx/nginx.access.log;

    # reverse proxy for HTTP connections
    location / {
        proxy_pass http://python:5000;
        proxy_redirect off;

        proxy_set_header Host $host;
        proxy_set_header X-Real-IP $remote_addr;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    }

    location /socket.io {

        # Default proxy params
        proxy_set_header Host $http_host;
        proxy_set_header X-Real-IP $remote_addr;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        proxy_set_header X-Forwarded-Proto $scheme;

        proxy_http_version 1.1;
        proxy_buffering off;
        proxy_set_header Upgrade $http_upgrade;
        proxy_set_header Connection "Upgrade";
        proxy_pass http://python:5000/socket.io;
    }

    # reverse proxy for Socket.IO connections
    #location ^~/socket.io {
    #
    #    # Default proxy params
    #    proxy_set_header Host $http_host;
    #    proxy_set_header X-Real-IP $remote_addr;
    #    proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    #    proxy_set_header X-Forwarded-Proto $scheme;
    #
    #    # prevents 502 bad gateway error
    #    proxy_buffers 8 32k;
    #    proxy_buffer_size 64k;
    #
    #    # Enabled Web Socket
    #    proxy_http_version 1.1;
    #    proxy_buffering off;
    #    proxy_set_header Upgrade $http_upgrade;
    #    proxy_set_header Connection "Upgrade";
    #    proxy_pass http://python:5000/socket.io/;
    #
    #    proxy_connect_timeout       300;
    #    proxy_send_timeout          300;
    #    proxy_read_timeout          300;
    #    send_timeout                30m;
    #
    #    proxy_set_header X-NginX-Proxy true;
    #}
}